//-------------------------------------------------------------------------- 
// break motors                       		                                     
//-------------------------------------------------------------------------- 
void run_break(){
  modeR=0; modeL=0;                     // mode 0 means break the motor  
}

//-------------------------------------------------------------------------- 
// adjustment by front wall        		                                           
//-------------------------------------------------------------------------- 
void adjust(){
  fS=0;                                 // set low speed    
  while(abs((sensFR-DISFR)-(sensFL-DISFL))>20){  // do adjustment when difference of sensor value larger than threshold(20)
    if ((sensFR-DISFR)>(sensFL-DISFL)) { 
      modeR=2; modeL=1;                 // turn right 
    } else { 
      modeR=1; modeL=2;                 // turn left 
    } 
  } 
  run_break();
}

//-------------------------------------------------------------------------- 
// slow start of the motors                 
//-------------------------------------------------------------------------- 
void slow_start(){
  fS=0;                                 // set low speed 
  modeR=modeL=1;                        // set mode for run forward  
  cntR=0; stepR=SLOWSTP;                // run "SLOWSTP" step at low speed
  while (cntR<stepR);                   // wait during run "SLOWSTP" step
}

//-------------------------------------------------------------------------- 
//	run forwad of 1 maze area                
//-------------------------------------------------------------------------- 
void run_step(){
  slow_start();
  fS=1;                                 // change to high speed 
  cntR=0; stepR=STEP1-SLOWSTP;             
  while (cntR<stepR);
  run_break();
}  

//-------------------------------------------------------------------------- 
// 90 degree turn right           		                                     
//-------------------------------------------------------------------------- 
void run_R90(){ 
  fS=0;                                 // set low speed  
  cntR=0; stepR=R90;                    // set motor step for turn 90 degree 
  modeR=2; modeL=1;                     // right motor: reverse, left motor: forward
  while (cntR<stepR);
  run_break();
}  

//-------------------------------------------------------------------------- 
// 90 degree turn left     		                                     
//-------------------------------------------------------------------------- 
void run_L90(){
  fS=0;                                 // set low speed  
  cntL=0; stepL=L90;                    // set motor step for turn 90 degree   
  modeR=1; modeL=2;                     // right motor: forward, left motor: reverse
  while (cntL<stepL);
  run_break();
}  

//-------------------------------------------------------------------------- 
// u-turn       		                                     
//-------------------------------------------------------------------------- 
void run_R180(){ 
  fS=0;                                 // set low speed 
  cntR=0; stepR=R180;                   // set motor step for turn 180 degree     
  modeR=2; modeL=1;                     // right motor: reverse, left motor: forward   
  while (cntR<stepR);
  run_break();
}  

//--------------------------------------------------------------------------
// run forward and u-turn when front wall detected
//--------------------------------------------------------------------------
void run_Turn(byte n){
  while (1){
    slow_start();
    fS=1;                               //  set high speed 
    while (sensFR<DISFR); // run forward to normal distanse from front wall 
    adjust();                           // adjestment by front wall    
    if (n==0) run_R180(); else run_R90();   // u-turn or turn right by the value of n
  }
} 


