
//-------------------------------------------------------------------------- 
// left hand method using direction history                                                 
//  priority is left, front and right. if all the wall exists, then u-turn.                     
//-------------------------------------------------------------------------- 
void run_Hidarite(){
  byte wF, wR, wL;               // flag for front right left walls 
  byte wS;                       // flag for sensing the walls  
  byte mapF, mapR, mapL;         // variable to read the history 
  byte mx,my;                    // x and y axis of mouse, start posisiton is 0,0  
  byte md;                       // direction of the mouse north:1, east:2, south:4, west:8 
  
  mapF=0; mapR=0; mapL=0;                     // initiallize 
  mx=0; my=0; md=1;                           //   
  wF=0; wR=1; wL=1;                           //  
  mmap[0][0].d=1;                             // inital direction is north (1)  

  while (digitalRead(START)==HIGH){           // repeat durning no sw input detection (push start-sw to exit )

  // reade history mapF,mapR,mapL are the history of front, right, left area)
  // no access to the out of range
    switch (md){
      case 1: if (my<15) mapF=mmap[my+1][mx].d; // when mouse direction is north,
              if (mx<15) mapR=mmap[my][mx+1].d; 
              if (mx>0)  mapL=mmap[my][mx-1].d; 
              break;
      case 2: if (mx<15) mapF=mmap[my][mx+1].d; // when mouse direction is east,
              if (my>0)  mapR=mmap[my-1][mx].d; 
              if (my<15) mapL=mmap[my+1][mx].d; 
              break;
      case 4: if (my>0)  mapF=mmap[my-1][mx].d; // when mouse direction is south,
              if (mx>0)  mapR=mmap[my][mx-1].d; 
              if (mx<15) mapL=mmap[my][mx+1].d; 
              break;     
      case 8: if (mx>0)  mapF=mmap[my][mx-1].d; // when mouse direction is west,
              if (my<15) mapR=mmap[my+1][mx].d; 
              if (my>0)  mapL=mmap[my-1][mx].d; 
              break;
    }
  
// Decision by left hand method
    if (wL ==0 && (mapL==0 || mapL==DtoL[md]))      // left turn when no left wall and no history or available history
      {run_L90(); md=DtoL[md]; }               
    else if (wF==0 && (mapF==0 || mapF==md)){}      // go forward when no front wall and no history or available history (pass the turn process)
    else if (wR==0 && (mapR==0 || mapR==DtoR[md]))  // right turn when no left wall and no history or available history
      {run_R90(); md=DtoR[md]; }                     
    else {run_R180(); md=DtoR[md]; md=DtoR[md];}    //u-turn  

// go forward and detect walls 
    wS=0; wF=0; wR=0; wL=0;                         // reset of wall flags 
    slow_start();                                   // slow start
    stepR=STEP1-SLOWSTP;
    fS=1;                                           // change high speed 
    while (cntR<stepR){                             // go forward   
      if (cntR > (STEP1*2/3) && wS==0){             // wall detection when the mouse run 2/3 step of area 
        wS=1;                                       // set flag to detect wall at once.                               
        if (sensR > DISRMAX) wR=1; else wR=0;       // detection of right wall 
        if (sensL > DISLMAX) wL=1; else wL=0;       // detection of left wall 
        if ((sensFR>DISFMAX || sensFL>DISFMAX)){ wF=1; break; }  // detection of front wall. exit from loop when front wall detected.   
      }
    } 
    
    // go forwrd to adjust distanse of front wall, when exit the above loop by front wall detection. 
    if (wF==1){                                     
      while (sensFR<DISFR);                         // go forward to have normal distance to front wall  
      adjust();                                     // adjustment by front wall 
    } 

// write map and history ( opposit direction of out of the area ) 
// record map after update mouse axis                                  
    switch (md){  
      case 1: mmap[my][mx].d=4; my++; mmap[my][mx].n=wF; mmap[my][mx].e=wR; mmap[my][mx].w=wL; break; 
      case 2: mmap[my][mx].d=8; mx++; mmap[my][mx].e=wF; mmap[my][mx].s=wR; mmap[my][mx].n=wL; break;
      case 4: mmap[my][mx].d=1; my--; mmap[my][mx].s=wF; mmap[my][mx].w=wR; mmap[my][mx].e=wL; break;
      case 8: mmap[my][mx].d=2; mx--; mmap[my][mx].w=wF; mmap[my][mx].n=wR; mmap[my][mx].s=wL; break;
    } 
    if (mx==0 && my==0) { run_break(); break; }      // finish search run when mouse return start position  
  }
}

