
//-------------------------------------------------------------------------- 
//  interrupt by timer 2	                                              	 
//-------------------------------------------------------------------------- 
void SensAndMotor(void) {    

// motor rotation,  mode = 0:free, 1:forward,  2:reverse,  3:break
// right motor rotation 
  if (timR>0) timR--;                         // count down timR when timR=0 do next process
  if (timR==0) {
    if (fR==0) timR=LSPD; else timR=HSPD;
    if (modeR==1) {if (patR < 3) patR++; else patR = 0; }
    if (modeR==2) {if (patR > 0) patR--; else patR = 3; }     
    cntR++;                                   // count up right moter step 
  }
// left motor rotation 
  if (timL>0) timL--;                         //count down timL when timL=0 do next process
  if (timL==0) {
    if (fL==0) timL=LSPD; else timL=HSPD;
    if (modeL==1) {if (patL < 3) patL++; else patL = 0; }
    if (modeL==2) {if (patL > 0) patL--; else patL = 3; }          
    cntL++;                                   // count up left moter step  
  }
    
  if (modeR==0 || modeL==0) { patR=4; patL=4; }  // motor free when mode=0  
  PORTA.OUT &=0xf0; PORTA.OUT |= RMOTOR[patR];        // pattern output to right motor
  PORTE.OUT &=0xf0; PORTE.OUT |= LMOTOR[patL];        // pattern output to left motor

// read sensors
// 1st-step:measure background during LED-off, 2nd-step: measure reflecting light during LED-on. sensor value is differnce of both.
  if (timS<20) timS++; else timS=0;          // set counter timS  
  if (timS==0){ 
    sensFRB=analogRead(PT_FR);               // measure all background values 
    sensFLB=analogRead(PT_FL);
    sensRB=analogRead(PT_R);
    sensLB=analogRead(PT_L); 
    digitalWrite(LEDOUT, HIGH);              // LED-ON  
    delayMicroseconds(100);                   // wait 50 microseconds
    sensFR=float(analogRead(PT_FR)-sensFRB)*KFR;        // mieasure sensor during LED-ON. 
    sensFL=float(analogRead(PT_FL)-sensFLB)*KFL;
    sensR =float(analogRead(PT_R) -sensRB)*KR;
    sensL =float(analogRead(PT_L) -sensLB)*KL;  
    digitalWrite(LEDOUT, LOW);               // LED-OFF
  }  

// set motor control flag by distance of both side walls 
// use only right wall when right wall detected,  use left wall when detected left wall only.
  if (fS==1){                                   // do the following process, when flag fS=1
    fR=fL=1;                                    // set high speed for both motor
    if(sensR>DISRMAX){                          // when right wall exists,   
      if ((sensR-DISR)>20) fL=0;                // set low speed for left moter, when close to the right wall 
      if ((sensR-DISR)<-20) fR=0;               // set low speed for right moter, when close to the left wall       
    } else if(sensL>DISLMAX){                   // when existing left wall only, 
      if ((sensL-DISL)>20) fR=0;                // similar to the control by right wall.
      if ((sensL-DISL)<-20) fL=0;
    }
  } else { fR=fL=0; }                           // when fS=0, set low speed for both motor

}

